﻿/*
Copyright (c) 2010 by Nguyen Duc Minh minhndm@yahoo.com
This script may be used for non-commercial purposes only. For any
commercial purposes, please contact the author.
*/
String.prototype.namespace = function(separator) { var ns = this.split(separator || '.'), p = window; for (i = 0; i < ns.length; i++) { p = p[ns[i]] = p[ns[i]] || {}; } };

"VI.VIChat.Client".namespace();

VI.VIChat.Client.Init = function() {
VI.VIChat.Client.StopRefresh = false;
VI.VIChat.Client.CheckUsersRefresh = 5000;
VI.VIChat.Client.CheckMessagesRefresh = 1000;
}

VI.VIChat.Client.Online = function(user) {
VI.VIChat.Client.Init();
$.post("/Chat/ActivateUser", { user: user }, VI.VIChat.Client.OnlineCallBack);
username = user;
}

VI.VIChat.Client.OnlineCallBack = function() {
VI.VIChat.Client.CheckUsers();
VI.VIChat.Client.CheckMessages();
}

VI.VIChat.Client.CheckUsers = function() {

$.getJSON("/Chat/GetActiveUsers", VI.VIChat.Client.CheckUsersCallback);
if (!VI.VIChat.Client.StopRefresh) {
setTimeout(VI.VIChat.Client.CheckUsers, VI.VIChat.Client.CheckUsersRefresh);
}
}

VI.VIChat.Client.CheckUsersCallback = function(response) {
if (response.length > 0) {
VI.VIChat.Client.ArrangeUsers(response);
}
}

VI.VIChat.Client.offChat = function() {
VI.VIChat.Client.StopRefresh = true;
for (x in chatBoxes) {
$('#chatbox_' + chatBoxes[x]).css('display', 'none');
$('#chatbox_' + chatBoxes[x]).remove();
}

if ($("#userbox").length > 0) {
$("#userbox").html('');
$('#userbox').css('display', 'none');
$('#userbox').remove();
}
chatBoxes = new Array();
var el = document.getElementById("userbox");
if (el != null) {
var par = el.parentNode;
par.removeChild(el);
}
VI.VIChat.Client.Offline();
}

VI.VIChat.Client.Offline = function() {
$.post("/Chat/DeactivateUser", {user:username }, VI.VIChat.Client.OfflineCallBack);
}

VI.VIChat.Client.OfflineCallBack = function() {
if ($("#userbox").length > 0) {
$("#userbox").html('');
$('#userbox').css('display', 'none');
$('#userbox').remove();
}
}

VI.VIChat.Client.createUserBox = function() {
if ($("#userbox").length > 0) {
if ($("#userbox").css('display') == 'none') {
$("#userbox").css('display', 'block');
}
return;
}

$(" <div />").attr("id", "userbox")
.addClass("userbox")
.html('<div class="chatboxhead"><div class="userboxtitle">Users online</div><div class="chatboxoptions"><a href="javascript:void(0)" onclick="javascript:VI.VIChat.Client.toggleUserBoxGrowth()">-</a> <a href="javascript:void(0)" onclick="javascript:VI.VIChat.Client.offChat()">X</a></div><br clear="all"/></div><div class="userboxcontent"></div>')
.appendTo($("body"));

$("#userbox").css('bottom', '0px');

$("#userbox").css('right', '20px');

$("#userbox").show();
    
}

VI.VIChat.Client.ArrangeUsers = function(users) {
VI.VIChat.Client.createUserBox();
$("#userbox .userboxcontent").html('');
for (var i = 0; i < users.length; i++) {
var user = users[i];
if(user != username)
$("#userbox .userboxcontent").append('<div class="userboxuser"><span class="chatboxmessagefrom"><a href="javascript:void(0)" onclick="javascript:VI.VIChat.Client.chatWith(\'' + user + '\')">' + user + '</a></span></div>');
}
}

VI.VIChat.Client.SendMessage = function(to, mess) {
$.post("/Chat/SendMessage",{toUser : to, message : mess}, VI.VIChat.Client.SendMessageCallback);
}

VI.VIChat.Client.SendMessageCallback = function() {
  
}

VI.VIChat.Client.CheckMessages = function() {
$.getJSON("/Chat/CheckMessages", VI.VIChat.Client.CheckMessagesCallback);
if (!VI.VIChat.Client.StopRefresh) {
setTimeout(VI.VIChat.Client.CheckMessages, VI.VIChat.Client.CheckMessagesRefresh);
}
}

VI.VIChat.Client.CheckMessagesCallback = function(response) {
if (response.length > 0) {
VI.VIChat.Client.ArrangeMessages(response);
}
}

VI.VIChat.Client.ArrangeMessages = function(messList) {
for (var i = 0; i < messList.length; i++) {
chatboxtitle = messList[i].FromUser;
if ($("#chatbox_" + chatboxtitle).length <= 0) {
VI.VIChat.Client.createChatBox(chatboxtitle);
}
if ($("#chatbox_" + chatboxtitle).css('display') == 'none') {
$("#chatbox_" + chatboxtitle).css('display', 'block');
VI.VIChat.Client.restructureChatBoxes();
}

$("#chatbox_" + chatboxtitle + " .chatboxcontent").append('<div class="chatboxmessage"><span class="chatboxmessagefrom">' + messList[i].FromUser + ':&nbsp;&nbsp;</span><span class="chatboxmessagecontent">' + messList[i].Message + '</span></div>');

$("#chatbox_" + chatboxtitle + " .chatboxcontent").scrollTop($("#chatbox_" + chatboxtitle + " .chatboxcontent")[0].scrollHeight);
}
}
/*

Copyright (c) 2009 Anant Garg (anantgarg.com | inscripts.com)

This script may be used for non-commercial purposes only. For any
commercial purposes, please contact the author at 
anant.garg@inscripts.com

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

*/

var windowFocus = true;
var username;
var chatHeartbeatCount = 0;
var minChatHeartbeat = 1000;
var maxChatHeartbeat = 33000;
var chatHeartbeatTime = minChatHeartbeat;
var originalTitle;
var blinkOrder = 0;
var userboxWidth = 232;

var chatboxFocus = new Array();
var newMessages = new Array();
var newMessagesWin = new Array();
var chatBoxes = new Array();

$(document).ready(function() {
    originalTitle = document.title;
    //startChatSession();

    $([window, document]).blur(function() {
        windowFocus = false;
    }).focus(function() {
        windowFocus = true;
        document.title = originalTitle;
    });
});

VI.VIChat.Client.restructureChatBoxes = function(){
    align = 1;
    for (x in chatBoxes) {
        chatboxtitle = chatBoxes[x];

        if ($("#chatbox_" + chatboxtitle).css('display') != 'none') {
            if (align == 0) {
                $("#chatbox_" + chatboxtitle).css('right', '20px');
            } else {
                width = (align) * (225 + 7) + 20;
                $("#chatbox_" + chatboxtitle).css('right', width + 'px');
            }
            align++;
        }
    }
}

VI.VIChat.Client.chatWith = function(chatuser) {
    VI.VIChat.Client.createChatBox(chatuser);
    $("#chatbox_" + chatuser + " .chatboxtextarea").focus();
}

VI.VIChat.Client.createChatBox = function(chatboxtitle, minimizeChatBox) {
    if ($("#chatbox_" + chatboxtitle).length > 0) {
        if ($("#chatbox_" + chatboxtitle).css('display') == 'none') {
            $("#chatbox_" + chatboxtitle).css('display', 'block');
            VI.VIChat.Client.restructureChatBoxes();
        }
        $("#chatbox_" + chatboxtitle + " .chatboxtextarea").focus();
        return;
    }

    $(" <div />").attr("id", "chatbox_" + chatboxtitle)
	.addClass("chatbox")
	.html('<div class="chatboxhead"><div class="chatboxtitle">' + chatboxtitle + '</div><div class="chatboxoptions"><a href="javascript:void(0)" onclick="javascript:VI.VIChat.Client.toggleChatBoxGrowth(\'' + chatboxtitle + '\')">-</a> <a href="javascript:void(0)" onclick="javascript:VI.VIChat.Client.closeChatBox(\'' + chatboxtitle + '\')">X</a></div><br clear="all"/></div><div class="chatboxcontent"></div><div class="chatboxinput"><textarea class="chatboxtextarea" onkeydown="javascript:return VI.VIChat.Client.checkChatBoxInputKey(event,this,\'' + chatboxtitle + '\');"></textarea></div>')
	.appendTo($("body"));

    $("#chatbox_" + chatboxtitle).css('bottom', '0px');

    chatBoxeslength = 1;

    for (x in chatBoxes) {
        if ($("#chatbox_" + chatBoxes[x]).css('display') != 'none') {
            chatBoxeslength++;
        }
    }

    if (chatBoxeslength == 0) {
        $("#chatbox_" + chatboxtitle).css('right', '20px');
    } else {
        width = (chatBoxeslength) * (225 + 7) + 20;
        $("#chatbox_" + chatboxtitle).css('right', width + 'px');
    }

    chatBoxes.push(chatboxtitle);

    if (minimizeChatBox == 1) {
        minimizedChatBoxes = new Array();

        if ($.cookie('chatbox_minimized')) {
            minimizedChatBoxes = $.cookie('chatbox_minimized').split(/\|/);
        }
        minimize = 0;
        for (j = 0; j < minimizedChatBoxes.length; j++) {
            if (minimizedChatBoxes[j] == chatboxtitle) {
                minimize = 1;
            }
        }

        if (minimize == 1) {
            $('#chatbox_' + chatboxtitle + ' .chatboxcontent').css('display', 'none');
            $('#chatbox_' + chatboxtitle + ' .chatboxinput').css('display', 'none');
        }
    }

    chatboxFocus[chatboxtitle] = false;

    $("#chatbox_" + chatboxtitle + " .chatboxtextarea").blur(function() {
        chatboxFocus[chatboxtitle] = false;
        $("#chatbox_" + chatboxtitle + " .chatboxtextarea").removeClass('chatboxtextareaselected');
    }).focus(function() {
        chatboxFocus[chatboxtitle] = true;
        newMessages[chatboxtitle] = false;
        $('#chatbox_' + chatboxtitle + ' .chatboxhead').removeClass('chatboxblink');
        $("#chatbox_" + chatboxtitle + " .chatboxtextarea").addClass('chatboxtextareaselected');
    });

    $("#chatbox_" + chatboxtitle).click(function() {
        if ($('#chatbox_' + chatboxtitle + ' .chatboxcontent').css('display') != 'none') {
            $("#chatbox_" + chatboxtitle + " .chatboxtextarea").focus();
        }
    });

    $("#chatbox_" + chatboxtitle).show();
}

VI.VIChat.Client.closeChatBox = function(chatboxtitle) {
    $('#chatbox_' + chatboxtitle).css('display', 'none');
    VI.VIChat.Client.restructureChatBoxes();
}

VI.VIChat.Client.toggleUserBoxGrowth = function() {
    if ($('#userbox .userboxcontent').css('display') == 'none') {
        $('#userbox .userboxcontent').css('display', 'block');
    } else {
    $('#userbox .userboxcontent').css('display', 'none');
    }
}

VI.VIChat.Client.toggleChatBoxGrowth = function(chatboxtitle) {
    if ($('#chatbox_' + chatboxtitle + ' .chatboxcontent').css('display') == 'none') {

        var minimizedChatBoxes = new Array();

        if ($.cookie('chatbox_minimized')) {
            minimizedChatBoxes = $.cookie('chatbox_minimized').split(/\|/);
        }

        var newCookie = '';

        for (i = 0; i < minimizedChatBoxes.length; i++) {
            if (minimizedChatBoxes[i] != chatboxtitle) {
                newCookie += chatboxtitle + '|';
            }
        }

        newCookie = newCookie.slice(0, -1)


        $.cookie('chatbox_minimized', newCookie);
        $('#chatbox_' + chatboxtitle + ' .chatboxcontent').css('display', 'block');
        $('#chatbox_' + chatboxtitle + ' .chatboxinput').css('display', 'block');
        $("#chatbox_" + chatboxtitle + " .chatboxcontent").scrollTop($("#chatbox_" + chatboxtitle + " .chatboxcontent")[0].scrollHeight);
    } else {

        var newCookie = chatboxtitle;

        if ($.cookie('chatbox_minimized')) {
            newCookie += '|' + $.cookie('chatbox_minimized');
        }


        $.cookie('chatbox_minimized', newCookie);
        $('#chatbox_' + chatboxtitle + ' .chatboxcontent').css('display', 'none');
        $('#chatbox_' + chatboxtitle + ' .chatboxinput').css('display', 'none');
    }

}

VI.VIChat.Client.checkChatBoxInputKey = function(event, chatboxtextarea, chatboxtitle) {

    if (event.keyCode == 13 && event.shiftKey == 0) {
        message = $(chatboxtextarea).val();
        message = message.replace(/^\s+|\s+$/g, "");

        $(chatboxtextarea).val('');
        $(chatboxtextarea).focus();
        $(chatboxtextarea).css('height', '44px');
        if (message != '') {
            VI.VIChat.Client.SendMessage(chatboxtitle, message);
            $("#chatbox_" + chatboxtitle + " .chatboxcontent").append('<div class="chatboxmessage"><span class="chatboxmessagefrom">' + username + ':&nbsp;&nbsp;</span><span class="chatboxmessagecontent">' + message + '</span></div>');
            $("#chatbox_" + chatboxtitle + " .chatboxcontent").scrollTop($("#chatbox_" + chatboxtitle + " .chatboxcontent")[0].scrollHeight);
        }
        return false;
    }

    var adjustedHeight = chatboxtextarea.clientHeight;
    var maxHeight = 94;

    if (maxHeight > adjustedHeight) {
        adjustedHeight = Math.max(chatboxtextarea.scrollHeight, adjustedHeight);
        if (maxHeight)
            adjustedHeight = Math.min(maxHeight, adjustedHeight);
        if (adjustedHeight > chatboxtextarea.clientHeight)
            $(chatboxtextarea).css('height', adjustedHeight + 8 + 'px');
    } else {
        $(chatboxtextarea).css('overflow', 'auto');
    }

}

/**
* Cookie plugin
*
* Copyright (c) 2006 Klaus Hartl (stilbuero.de)
* Dual licensed under the MIT and GPL licenses:
* http://www.opensource.org/licenses/mit-license.php
* http://www.gnu.org/licenses/gpl.html
*
*/

jQuery.cookie = function(name, value, options) {
    if (typeof value != 'undefined') { // name and value given, set cookie
        options = options || {};
        if (value === null) {
            value = '';
            options.expires = -1;
        }
        var expires = '';
        if (options.expires && (typeof options.expires == 'number' || options.expires.toUTCString)) {
            var date;
            if (typeof options.expires == 'number') {
                date = new Date();
                date.setTime(date.getTime() + (options.expires * 24 * 60 * 60 * 1000));
            } else {
                date = options.expires;
            }
            expires = '; expires=' + date.toUTCString(); // use expires attribute, max-age is not supported by IE
        }
        // CAUTION: Needed to parenthesize options.path and options.domain
        // in the following expressions, otherwise they evaluate to undefined
        // in the packed version for some reason...
        var path = options.path ? '; path=' + (options.path) : '';
        var domain = options.domain ? '; domain=' + (options.domain) : '';
        var secure = options.secure ? '; secure' : '';
        document.cookie = [name, '=', encodeURIComponent(value), expires, path, domain, secure].join('');
    } else { // only name given, get cookie
        var cookieValue = null;
        if (document.cookie && document.cookie != '') {
            var cookies = document.cookie.split(';');
            for (var i = 0; i < cookies.length; i++) {
                var cookie = jQuery.trim(cookies[i]);
                // Does this cookie string begin with the name we want?
                if (cookie.substring(0, name.length + 1) == (name + '=')) {
                    cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                    break;
                }
            }
        }
        return cookieValue;
    }
};